#!/usr/bin/perl

use Lingua::ZH::CEDICT;

my $dict = Lingua::ZH::CEDICT->new();
$dict->init();

$word = $ARGV[0] || '庳';
@results = ();

$dict->startMatch($word);
while (my $e = $dict->match()) {
    push @results, $e;
}

for $e (sort { length($b->[0]) <=> length($a->[0]) } @results){ 
    #      trad    simp    pinyin pinyin w/o tones  english
    print "$e->[0] ". u2h($e->[0]) . " $e->[1] " . u2h($e->[1]) ." [$e->[2] / $e->[3]] $e->[4]\n";
}

sub u2h {
    my $str = shift;
    my $res;
    for(my $i=0; $i<length($str); $i++){
	$c = substr($str, $i, 1);
	$res .= sprintf("%x ", ord($c));
    }
    return $res;
}
